SystemOrganization addCategory: #'OpenCourses-Tests'!
SystemOrganization addCategory: #OpenCourses!
SystemOrganization addCategory: #'OpenCourses-Undergrad'!

WATask subclass: #OcRootTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcRootTask class methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:08'!
canBeRoot 
	^ true.! !

!OcRootTask methodsFor: 'running' stamp: 'cmb 6/28/2013 15:37'!
go

	| loginAnswer user |
 	loginAnswer := self call: OcLoginComponent new.
 	loginAnswer = #registerUser
  		ifTrue: [user := self call: OcRegisterComponent new]
  		ifFalse: [user := loginAnswer].
 	user ifNotNil: [
  		self session login: user.
  		self call: OcMainComponent new].! !

WAFileLibrary subclass: #OcLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcLibrary class methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:09'!
applicationName

	^ 'OpenCourses'! !

!OcLibrary methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 15:31'!
openCoursesCss

	^ '
body {
	font: normal 100% Arial, Helvetica, Verdana, sans-serif;
}
 
.generic {
	font-family: Geneva, Arial, Helvetica, sans-serif;
 	font-style: normal;
	font-weight: normal;
 	font-size: 14px;
	text-align: center;
 	color : #663300;
	background: #AAAAFF;
 	padding: 20px;
 	margin-top: 20px;
 	margin-left: auto;
	margin-right: auto;
 	border: 1px solid #663300;
 	width: 75%;
	height: auto;
}

.lightbox {
	background-color:#FFFFFF;
}

.errorMessage {
	background-color: #ffb0b0;
 	border: 1px solid #ee0000;
 	padding: 5px;
 	margin-bottom: 10px;
}

.infoMessage {
	background-color: #fbffcc;
 	border: 1px solid #eda33a;
 	padding: 5px;
 	margin-bottom: 10px;
}

.copyright {
	font-family: Geneva, Arial, Helvetica, sans-serif;
	font-size: 10px;
 	font-style: normal;
 	font-weight: normal;
 	color: #663300;
 	text-align: left;
 	margin-left: 20px;
}

.menu {
	font-family: Geneva, Arial, Helvetica, sans-serif;
	font-size: 10px;
 	font-style: normal;
 	font-weight: normal;
 	color: #663300;
	background: #FFAAAA;
 	text-align: center;
 	margin: auto;
	width: 20%;
	height: 100%;
	float: left;
}

.list {
	font-family: Geneva, Arial, Helvetica, sans-serif;
	font-size: 14px;
 	font-style: normal;
 	font-weight: normal;
 	color: #663300;
	background: #AAFFAA;
 	text-align: center;
	float: right;
	margin: auto;
	width: 80%;
	height: 100%;
}

.clear {
	clear: both;
	height: 1px;
	overflow: hidden;
	font-size:0pt;
	margin-top: -1px;
}

a {
	color : #663300;
 	text-decoration: underline;
}'! !

!OcLibrary methodsFor: 'accessing' stamp: 'cmb 6/25/2013 22:10'!
selectorsToInclude

	^ #( openCoursesCss )! !

WAComponent subclass: #OcGroupEditor
	instanceVariableNames: 'group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcGroupEditor methodsFor: 'accessing' stamp: 'cmb 6/28/2013 17:53'!
group
	^ group! !

!OcGroupEditor methodsFor: 'accessing' stamp: 'cmb 6/28/2013 17:53'!
group: anObject
	group := anObject! !

!OcGroupEditor methodsFor: 'initialization' stamp: 'cmb 6/28/2013 19:10'!
initialize 

	super initialize.
	self group: OcGroup new.
	! !

!OcGroupEditor methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 19:10'!
newGroup

	self group: OcGroup new.! !

!OcGroupEditor methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 17:06'!
renderButtonsOn: html

 	html
  		tableData;
  		tableData: [
   		html submitButton
    			callback: [self answer: true];
    			value: 'Save'.
   		html submitButton
    			callback: [self answer: false];
    			value: 'Cancel'].! !

!OcGroupEditor methodsFor: 'rendering' stamp: 'cmb 6/28/2013 17:05'!
renderContentOn: html

	html div
  		class: 'generic lightbox';
  			with: [
   			html heading: 'Creating group'.
   			html form: [
    				html table: [
     					html
      					tableRow: [self renderSubjectInputOn: html];
      					tableRow: [self renderInstructorInputOn: html];
							tableRow: [self renderButtonsOn: html]]]].
	! !

!OcGroupEditor methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 17:04'!
renderInstructorInputOn: html

	html
 		tableData: [html text: 'Instructor: '];
  		tableData: [html textInput on: #instructor of: self group].! !

!OcGroupEditor methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 17:04'!
renderSubjectInputOn: html

	html
 		tableData: [html text: 'Subject: '];
  		tableData: [html textInput on: #subject of: self group].! !

WAComponent subclass: #OcLoginComponent
	instanceVariableNames: 'password messageComponent loginID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:09'!
applicationName 
	^ OcLibrary applicationName.
	
	! !

!OcLoginComponent methodsFor: 'initialization' stamp: 'cmb 6/25/2013 23:18'!
initialize 

	super initialize.
	self messageComponent: OcMessageComponent new.  ! !

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:16'!
loginFailed

	self messageComponent errorMessage: 'Login failed.'.! !

!OcLoginComponent methodsFor: 'accessing' stamp: 'cmb 6/28/2013 11:04'!
loginID
	^ loginID! !

!OcLoginComponent methodsFor: 'accessing' stamp: 'cmb 6/28/2013 11:04'!
loginID: anObject
	loginID := anObject! !

!OcLoginComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:31'!
messageComponent
	^ messageComponent! !

!OcLoginComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:31'!
messageComponent: anObject
	messageComponent := anObject! !

!OcLoginComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:12'!
password
	^ password! !

!OcLoginComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:12'!
password: anObject
	password := anObject! !

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:17'!
registerUser
 
	self answer: #registerUser.! !

!OcLoginComponent methodsFor: 'rendering' stamp: 'cmb 6/25/2013 21:13'!
renderContentOn: html
	html div
 	class: 'generic';
 		with: [
  			html
   			heading: self applicationName;
   			render: self messageComponent;
   			text: 'Please login with e-mail and password:';
   			form: [
    				self
     					renderTextInputOn: html;
     					renderPasswordInputOn: html;
     					renderLoginButtonOn: html;
     					renderSignUpAnchorOn: html]].! !

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:15'!
renderLoginButtonOn: html

	html submitButton
  		callback: [self validateLogin];
  		text: 'Login'.! !

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:35'!
renderPasswordInputOn: html

	html passwordInput
  		callback: [:value | self password: (OcUser hashPassword: value)];
  		value: ''.! !

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:15'!
renderSignUpAnchorOn: html

	html paragraph with: [html anchor
  		callback: [self registerUser];
  		with: [html text: 'Sign up for the ', self applicationName]].! !

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 11:05'!
renderTextInputOn: html
	html textInput
  		on: #loginID of: self;
  		value: ''.
 	html space.! !

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 11:06'!
validateLogin

	| user |
 	user := self session findUser: self loginID email: self loginID.
 	(user notNil and: [user password = self password])
  		ifTrue: [self answer: user]
  		ifFalse: [self loginFailed].! !

WAComponent subclass: #OcMainComponent
	instanceVariableNames: 'groupEditor menuComponent viewComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcMainComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 17:09'!
createNewGroup
 
	| answer |
 	answer := self call: self groupEditor newGroup.
 	answer ifTrue: [self listComponent items add: self groupEditor task].! !

!OcMainComponent methodsFor: 'accessing' stamp: 'cmb 6/28/2013 17:10'!
groupEditor
	^ groupEditor! !

!OcMainComponent methodsFor: 'accessing' stamp: 'cmb 6/28/2013 17:10'!
groupEditor: anObject
	groupEditor := anObject! !

!OcMainComponent methodsFor: 'initialization' stamp: 'cmb 6/28/2013 19:05'!
initialize 

	super initialize.
	self groupEditor: OcGroupEditor new.
	Transcript show: 'before init menu comp';cr.
  	self menuComponent: (self initializeMenuComponent).
	self viewComponent: (self initializeViewComponent).! !

!OcMainComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 18:53'!
initializeMenuComponent

	self menuComponent: OcMenuComponent new.
	self menuComponent
		addEntry: 'Edit User' withAction: [];
		addEntry: 'Create Material' withAction: [];
		addEntry: 'Create Group' withAction: [self createNewGroup];
  		addEntry: 'Logoff' withAction: [self session logout. self answer: true].
	^menuComponent.
	
! !

!OcMainComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 19:06'!
initializeViewComponent

	self viewComponent: OcViewComponent new.
	^viewComponent.
	
! !

!OcMainComponent methodsFor: 'accessing' stamp: 'cmb 6/28/2013 17:29'!
menuComponent
	^ menuComponent! !

!OcMainComponent methodsFor: 'accessing' stamp: 'cmb 6/28/2013 17:29'!
menuComponent: anObject
	menuComponent := anObject! !

!OcMainComponent methodsFor: 'rendering' stamp: 'cmb 6/28/2013 19:05'!
renderContentOn: html
 
	html div
  		class: 'generic';
  			with:[
   			html heading: 'OpenCourses'.
				html break.
   			html div
    				class: 'menu';
					id: 'menu';
    				with: self menuComponent.
   			html div
    				class: 'list';
    				id: 'list';
    				with: self viewComponent.
				html div
    				class: 'clear'.
				].! !

!OcMainComponent methodsFor: 'accessing' stamp: 'cmb 6/28/2013 19:05'!
viewComponent
	^ viewComponent! !

!OcMainComponent methodsFor: 'accessing' stamp: 'cmb 6/28/2013 19:05'!
viewComponent: anObject
	viewComponent := anObject! !

WAComponent subclass: #OcMenuComponent
	instanceVariableNames: 'entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcMenuComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 18:45'!
addEntry: aString withAction: aBlock
 
	^ self entries add: aString -> aBlock! !

!OcMenuComponent methodsFor: 'accessing' stamp: 'cmb 6/28/2013 17:22'!
entries
	^ entries! !

!OcMenuComponent methodsFor: 'accessing' stamp: 'cmb 6/28/2013 17:22'!
entries: anObject
	entries := anObject! !

!OcMenuComponent methodsFor: 'initialization' stamp: 'cmb 6/28/2013 18:23'!
initialize

	super initialize.  
	self entries: OrderedCollection new.
	! !

!OcMenuComponent methodsFor: 'rendering' stamp: 'cmb 6/28/2013 18:55'!
renderContentOn: html

	html heading: 'Menu'.
	self entries
  		do: [:entry |
   		html anchor
    			callback: entry value;
    			with: entry key]
  		separatedBy: [html break].
	! !

WAComponent subclass: #OcMessageComponent
	instanceVariableNames: 'messageString messageType wasShown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcMessageComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:27'!
errorMessage: aString

	self
  		messageString: aString;
  		messageType: 'error';
  		wasShown: false.! !

!OcMessageComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:27'!
infoMessage: aString

	self
  		messageString: aString;
  		messageType: 'info';
  		wasShown: false.! !

!OcMessageComponent methodsFor: 'initialization' stamp: 'cmb 6/25/2013 21:26'!
initialize

	super initialize.
 	self wasShown: true.! !

!OcMessageComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:26'!
messageString
	^ messageString! !

!OcMessageComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:26'!
messageString: anObject
	messageString := anObject! !

!OcMessageComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:26'!
messageType
	^ messageType! !

!OcMessageComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:26'!
messageType: anObject
	messageType := anObject! !

!OcMessageComponent methodsFor: 'rendering' stamp: 'cmb 6/25/2013 21:27'!
renderContentOn: html

	self wasShown ifTrue: [^ self].
 	html div
  		class: self messageType, 'Message';
  		with: self messageString.
 	self wasShown: true.! !

!OcMessageComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:26'!
wasShown
	^ wasShown! !

!OcMessageComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:26'!
wasShown: anObject
	wasShown := anObject! !

WAComponent subclass: #OcRegisterComponent
	instanceVariableNames: 'user repeatedPassword messageComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 11:36'!
emailIsValid: anEmail
	^anEmail includesSubString: '@'.
  ! !

!OcRegisterComponent methodsFor: 'initialization' stamp: 'cmb 6/25/2013 21:52'!
initialize 
	
	super initialize.
	self user: OcUser new.	
	self messageComponent: OcMessageComponent new.  ! !

!OcRegisterComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:32'!
messageComponent
	^ messageComponent! !

!OcRegisterComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:32'!
messageComponent: anObject
	messageComponent := anObject! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 14:32'!
registerUser

	self user userName isEmptyOrNil
  		ifTrue: [^ self messageComponent 
   		infoMessage: 'Please choose a username!!'].
	(self session findUserByUserName: self user userName)
		ifNotNil: [^ self messageComponent 
   		errorMessage: 'The username is already in use!!'].
	(self userNameIsValid: self user userName)
  		ifFalse: [^ self messageComponent 
   		errorMessage: 'Invalid username (invalid character @).'].
 	self user email isEmptyOrNil
  		ifTrue: [^ self messageComponent 
   		infoMessage: 'Please enter your e-mail address!!'].
	(self emailIsValid: self user email) 
  		ifFalse: [^ self messageComponent 
   		infoMessage: 'This e-mail address is not valid'].
 	(self session findUserByEmail: self user email)
  		ifNotNil: [^ self messageComponent 
   		errorMessage: 'The e-mail address is already registered!!'].
 	self user password = 0
  		ifTrue: [^ self messageComponent 
   		infoMessage: 'Please choose a password!!'].
 	self user password = self repeatedPassword
  		ifFalse: [^ self messageComponent 
   		infoMessage: 'Your repeated password does not match!!'].
 	self session database addUser: self user.
 	self answer: self user.! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:20'!
renderCancelButtonOn: html
 
	html submitButton
  		callback: [self answer: nil];
  		text: 'Cancel'.! !

!OcRegisterComponent methodsFor: 'rendering' stamp: 'cmb 6/25/2013 23:21'!
renderContentOn: html

	html div
  		class: 'generic';
  		with: [
   		html
    			heading: 'Register an account';
    			render: self messageComponent;
    			form: [
     				html table: [
      				self
       					renderUsernameTextInputOn: html;
       					renderEmailTextInputOn: html;
       					renderPasswordTextInputOn: html;
       					renderRepeatedPasswordTextInputOn: html.
      				html tableRow: [
       					html
        						tableData;
        						tableData: [
         						self renderSubmitButtonOn: html.
         						html space.
         						self renderCancelButtonOn: html]]]]].! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:21'!
renderEmailTextInputOn: html

	html tableRow: [
  		html
   		tableData: 'E-mail';
   		tableData: [
    			html textInput
     				callback: [:value | self user email: value];
     				value: self user email]].! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:35'!
renderPasswordTextInputOn: html

	html tableRow: [
  		html
   		tableData: 'Password';
   		tableData: [
    			html passwordInput
     				callback: [:value | self user password: (OcUser hashPassword: value)]]].! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:35'!
renderRepeatedPasswordTextInputOn: html

	html tableRow: [
  		html
   		tableData: 'Repeat password';
   		tableData: [
    			html passwordInput
     				callback: [:value | self repeatedPassword: (OcUser hashPassword: value)]]].! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:59'!
renderSubmitButtonOn: html

	html submitButton
  		callback: [self registerUser];
  		text: 'Register'.! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:21'!
renderUsernameTextInputOn: html

	html tableRow: [
  		html
  		tableData: 'Username';
  		tableData: [
   		html textInput
    			callback: [:value | self user userName: value];
    			value: self user userName]].! !

!OcRegisterComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:18'!
repeatedPassword
	^ repeatedPassword! !

!OcRegisterComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:18'!
repeatedPassword: anObject
	repeatedPassword := anObject! !

!OcRegisterComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:18'!
user
	^ user! !

!OcRegisterComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:18'!
user: anObject
	user := anObject! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 14:27'!
userNameIsValid: anUserName
	^(anUserName includesSubString: '@') not.
  ! !

WAComponent subclass: #OcViewComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcViewComponent methodsFor: 'rendering' stamp: 'cmb 6/28/2013 15:08'!
renderContentOn: html
	html heading: 'Workspace'.
	html break.
	html anchor
  		callback: [];
  		with: 'Material1'.
	html break.
	html anchor
  		callback: [];
  		with: 'Material2'.
	html break.
	html anchor
  		callback: [];
  		with: 'Material3'.! !

!OcViewComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 16:49'!
renderGroup: aGroup asRowOn: html

	html tableData: [html
  		tableData: aGroup subject;
  		tableData: aGroup instructor;
  		tableData: aGroup userList size asString + ' alunos'].! !

!OcViewComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 15:41'!
renderMaterial: aMaterial asRowOn: html

	html tableData: [html
  		tableData: aMaterial creationDate asString;
  		tableData: aMaterial title;
  		tableData: aMaterial owner;
  		tableData: aMaterial materialDescription].! !

Object subclass: #Data
	instanceVariableNames: ''
	classVariableNames: 'Admin MaterialList UserList'
	poolDictionaries: ''
	category: 'OpenCourses'!

!Data class methodsFor: 'accessing' stamp: 'Su 5/13/2013 15:41'!
admin
	^Admin! !

!Data class methodsFor: 'accessing' stamp: 'Su 5/13/2013 15:41'!
admin: aUser
	Admin := aUser! !

!Data class methodsFor: 'accessing' stamp: 'jsa 5/13/2013 19:50'!
blankData
	UserList := Set new.
	MaterialList := Set new.
	Admin := nil.! !

!Data class methodsFor: 'accessing' stamp: 'jsa 5/11/2013 18:19'!
materialList
	^ MaterialList! !

!Data class methodsFor: 'accessing' stamp: 'jsa 5/11/2013 18:19'!
materialList: aMaterialList
	MaterialList := aMaterialList! !

!Data class methodsFor: 'accessing' stamp: 'jsa 5/11/2013 18:19'!
userList
	^ UserList! !

!Data class methodsFor: 'accessing' stamp: 'jsa 5/11/2013 18:19'!
userList: aUserList
	UserList := aUserList! !

!Data methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 15:07'!
renderContentOn: html
	
	  ! !

Object subclass: #DidacticMaterial
	instanceVariableNames: 'file url title authors owner licence creationDate lastUploadDate type tags materialDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!DidacticMaterial methodsFor: 'comparing' stamp: 'jsa 5/12/2013 16:57'!
= aDidacticMaterial
	aDidacticMaterial ifNotNil: [^ aDidacticMaterial url = self url].
	^ false! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
authors
	"Answer the value of authors"

	^ authors! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
authors: anObject
	"Set the value of authors"

	authors := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
creationDate
	"Answer the value of creationDate"

	^ creationDate! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
creationDate: anObject
	"Set the value of creationDate"

	creationDate := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
file
	"Answer the value of file"

	^ file! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
file: anObject
	"Set the value of file"

	file := anObject! !

!DidacticMaterial methodsFor: 'comparing' stamp: 'jsa 5/12/2013 16:58'!
hash
	^ self url hash! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
lastUploadDate
	"Answer the value of lastUploadDate"

	^ lastUploadDate! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
lastUploadDate: anObject
	"Set the value of lastUploadDate"

	lastUploadDate := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
licence
	"Answer the value of licence"

	^ licence! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
licence: anObject
	"Set the value of licence"

	licence := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/25/2013 22:31'!
materialDescription
	"Answer the value of description"

	^ materialDescription! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/25/2013 22:31'!
materialDescription: anObject
	"Set the value of description"

	materialDescription := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
owner
	"Answer the value of owner"

	^ owner! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
owner: anObject
	"Set the value of owner"

	owner := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
tags
	"Answer the value of tags"

	^ tags! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
tags: anObject
	"Set the value of tags"

	tags := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
title
	"Answer the value of title"

	^ title! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
title: anObject
	"Set the value of title"

	title := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
type
	"Answer the value of type"

	^ type! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
type: anObject
	"Set the value of type"

	type := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/12/2013 16:40'!
url
	"Answer the value of url"

	^ url! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/12/2013 16:40'!
url: anObject
	"Set the value of url"

	url := anObject! !

Object subclass: #DidacticMaterialSearchSpecs
	instanceVariableNames: 'title description authors owner licence creationDateStart creationDateEnd lastUploadDateStart lastUploadDateEnd type tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
authors
	"Answer the value of authors"

	^ authors! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
authors: anObject
	"Set the value of authors"

	authors := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
creationDateEnd
	"Answer the value of creationDateEnd"

	^ creationDateEnd! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
creationDateEnd: anObject
	"Set the value of creationDateEnd"

	creationDateEnd := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
creationDateStart
	"Answer the value of creationDateStart"

	^ creationDateStart! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
creationDateStart: anObject
	"Set the value of creationDateStart"

	creationDateStart := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
description
	"Answer the value of description"

	^ description! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
description: anObject
	"Set the value of description"

	description := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
lastUploadDateEnd
	"Answer the value of lastUploadDateEnd"

	^ lastUploadDateEnd! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
lastUploadDateEnd: anObject
	"Set the value of lastUploadDateEnd"

	lastUploadDateEnd := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
lastUploadDateStart
	"Answer the value of lastUploadDateStart"

	^ lastUploadDateStart! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
lastUploadDateStart: anObject
	"Set the value of lastUploadDateStart"

	lastUploadDateStart := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
licence
	"Answer the value of licence"

	^ licence! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
licence: anObject
	"Set the value of licence"

	licence := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'comparing' stamp: 'Su 5/12/2013 23:31'!
matches: aDidacticMaterial
	self title ifNotNil: [aDidacticMaterial title = self title ifFalse: [^ false]].
	self creationDateStart ifNotNil: [aDidacticMaterial creationDate > self creationDateStart ifFalse: [^ false]].
	self creationDateEnd ifNotNil: [aDidacticMaterial creationDate < self creationDateEnd ifFalse: [^ false]].
	self lastUploadDateStart ifNotNil: [aDidacticMaterial lastUploadDate > self lastUploadDateStart ifFalse: [^ false]].
	self lastUploadDateEnd ifNotNil: [aDidacticMaterial lastUploadDate < self lastUploadDateEnd ifFalse: [^ false]].
	self description ifNotNil: [aDidacticMaterial description = self description ifFalse: [^ false]].
	self owner ifNotNil: [aDidacticMaterial owner email = self owner ifFalse: [^ false]].
	self authors ifNotNil: [((aDidacticMaterial authors) includesAnyOf: (self authors)) ifFalse: [^ false]].
	self licence ifNotNil: [aDidacticMaterial licence = self licence ifFalse: [^false]].
	self type ifNotNil: [aDidacticMaterial type = self type ifFalse: [^ false]].
	self tags ifNotNil: [ ((aDidacticMaterial tags) includesAnyOf: (self tags)) ifFalse: [^ false]].
	^true! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
owner
	"Answer the value of owner"

	^ owner! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
owner: anObject
	"Set the value of owner"

	owner := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
tags
	"Answer the value of tags"

	^ tags! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
tags: anObject
	"Set the value of tags"

	tags := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
title
	"Answer the value of title"

	^ title! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
title: anObject
	"Set the value of title"

	title := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
type
	"Answer the value of type"

	^ type! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
type: anObject
	"Set the value of type"

	type := anObject! !

Object subclass: #DidaticStructure
	instanceVariableNames: 'id name creator ownerList visible topic'
	classVariableNames: 'StructureId'
	poolDictionaries: ''
	category: 'OpenCourses-Undergrad'!

!DidaticStructure commentStamp: 'RFG 5/11/2013 13:53' prior: 0!
Mudar o nome dessa classe. It represents: Lecture U Group U Subject U Courses!

DidaticStructure subclass: #Course
	instanceVariableNames: 'subjectList userList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Undergrad'!

!Course commentStamp: 'RFG 5/2/2013 11:43' prior: 0!
Represents a course in the system.!

!Course class methodsFor: 'instance creation' stamp: 'AP 5/12/2013 20:09'!
newNamed: aName withId: anId by: anUserId onTopic: aTopicId
	"Creates a new DidaticStructure with an Id, named aString and the creator indicated by anUserId."
	
	| newCourse
	  aTopic
	  sys		 |
	
	newCourse := super newNamed: aName  withId: anId by: anUserId onTopic: aTopicId.
	
	newCourse userList isNil
		ifTrue: [newCourse userList: OrderedCollection new].
		
	newCourse subjectList isNil
		ifTrue: [newCourse subjectList: OrderedCollection new].
		
	sys := System create.
	aTopic := sys findTopic: aTopicId.
	aTopic addCourse: newCourse.
	^newCourse! !

!Course methodsFor: 'inclusion' stamp: 'RFG 5/13/2013 15:38'!
addSubject: anId
	"Adds a subject into the course."

	subjectList add: anId.! !

!Course methodsFor: 'inclusion' stamp: 'RFG 5/13/2013 15:37'!
addUser: anId
	"Adds a user into the course."

	userList add: anId! !

!Course methodsFor: 'deletion' stamp: 'RFG 5/13/2013 19:43'!
delete
	"Removes the course from the System."

	| user 
	  system 
	  topic    |
	
	system := System create.
	
	userList do:[:userId |
		user := system findUser: userId.
		user withdrawCourse: (self id).
		].
	
	topic := system findTopic: (self topic).
	topic courseTable removeAt: (self id).! !

!Course methodsFor: 'remotion' stamp: 'RFG 5/13/2013 15:39'!
removeSubject: anId.
	"Removes the subject with the given ID."
	
	subjectList remove: anId! !

!Course methodsFor: 'remotion' stamp: 'RFG 5/13/2013 15:39'!
removeUser: anId.
	"Removes the user with the given ID."
	
	userList remove: anId! !

!Course methodsFor: 'accessing' stamp: 'RFG 5/11/2013 09:58'!
subjectList
	"Returns the list of subjects included in the course."

	^subjectList.! !

!Course methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:07'!
subjectList: aListOfIds
	"Sets the list of subjects included in the course."

	subjectList := aListOfIds.! !

!Course methodsFor: 'accessing' stamp: 'RFG 5/11/2013 10:36'!
userList
	"Returns the list of inscribed users."

	^userList.! !

!Course methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:07'!
userList: aListOfIds
	"Sets the list of inscribed users."

	userList := aListOfIds.! !

!DidaticStructure class methodsFor: 'instance creation' stamp: 'RFG 5/13/2013 12:21'!
newNamed: aName withId: anId by: anUserId onTopic: aTopicId
	"Creates a new DidaticStructure with an Id, named aString and the creator indicated by anUserId."

	| newDidaticStructure |
	
	newDidaticStructure := self new.
	
	newDidaticStructure id: anId.
	newDidaticStructure name: aName.
	newDidaticStructure creator: anUserId.
	newDidaticStructure topic: aTopicId.
	newDidaticStructure visible: False. 
	
	newDidaticStructure ownerList isNil
		ifTrue: [newDidaticStructure ownerList: OrderedCollection new].
	
	^newDidaticStructure.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 08:03'!
creator
	"Returns the creator."

	^creator.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:08'!
creator: anId
	"Sets the ID of the creator."

	creator := anId.! !

!DidaticStructure methodsFor: 'deletion' stamp: 'RFG 5/13/2013 19:08'!
delete
	"Removes the didatic structure from the system."

	^self subclassResponsibility.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/13/2013 12:22'!
id
	"Returns the id."

	^id.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/13/2013 12:22'!
id: anID
	"Sets the id."
	
	id := anID.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/10/2013 18:13'!
name
	"Returns the name."

	^name.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/10/2013 18:14'!
name: aString
	"Sets the name."

	name := aString.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 08:07'!
ownerList
	"Returns the list of owners."

	^ownerList.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:08'!
ownerList: aListOfIds
	"Sets the list of owners."

	ownerList := aListOfIds.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 14:26'!
topic
	"Returns the topic."

	^topic.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 14:26'!
topic: aTopic
	"Sets the topic."

	topic := aTopic.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 10:01'!
visible
	"Returns whether the structure is visible or not by non-owners users"

	^visible.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 10:03'!
visible: boolean
	"Sets whether the structure is visible or not by non-owners users"

	visible := boolean.! !

DidaticStructure subclass: #Lecture
	instanceVariableNames: 'subject userList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Undergrad'!

!Lecture commentStamp: 'RFG 5/10/2013 18:02' prior: 0!
Represents a Lecture of a Subject!

!Lecture class methodsFor: 'instance creation' stamp: 'RFG 5/13/2013 14:40'!
newNamed: aName withId: anId by: anUserId onTopic: aTopicId onSubject:  aSubjectId 
	"Creates a new Lecture in a Subject"

	| newLecture    
	  sys             |
	
	newLecture := super newNamed: aName withId: anId by: anUserId onTopic: aTopicId.
	newLecture subject: aSubjectId.
	
	newLecture userList isNil
		ifTrue: [newLecture subjectList: OrderedCollection new].
		
	sys := System create.
	(sys findSubject: aSubjectId) addLecture: newLecture.
	
	^newLecture.! !

!Lecture methodsFor: 'deletion' stamp: 'RFG 5/13/2013 15:32'!
delete
	"Removes a lecture from the system."

	| subject
	  sys       |
	
	sys := System create.
	subject := sys findSubject: (self subject).
	subject lectureTable removeKey: (self id).! !

!Lecture methodsFor: 'remotion' stamp: 'RFG 5/13/2013 18:46'!
removeUser: anId.
	"Removes the user with the given ID."
	
	userList remove: anId.! !

!Lecture methodsFor: 'accessing' stamp: 'RFG 5/11/2013 11:43'!
subject
	"Returns the lecture's subject."

	^subject.! !

!Lecture methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:10'!
subject: anSubjectId
	"Sets the lecture's subject."

	subject := anSubjectId.! !

!Lecture methodsFor: 'accessing' stamp: 'RFG 5/11/2013 11:43'!
userList
	"Returns the list of inscribed users."

	^userList.! !

!Lecture methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:10'!
userList: aListOfIds
	"Sets the list of inscribed users."

	userList := aListOfIds.! !

DidaticStructure subclass: #OcGroup
	instanceVariableNames: 'userList instructor subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Undergrad'!

!OcGroup commentStamp: 'RFG 5/9/2013 13:46' prior: 0!
Represents a group in the system. Set of students at inscribed in a subject with a instructor.!

!OcGroup class methodsFor: 'instance creation' stamp: 'RFG 5/13/2013 14:23'!
newNamed: aName withId: anId by: anUserId onSubject:  anSubjectId andInstructor: anInstructorId
	"Creates a new Group in a Subject and a instructor"
	
	| newGroup
	  system 
	  topicId     
	  subject     |
	
	system := System create.
	subject := system findSubject: anSubjectId.
	topicId := subject topic.
	newGroup := super newNamed: aName withId: anId by: anUserId onTopic: topicId.
	newGroup instructor: anInstructorId.
	newGroup subject: anSubjectId.
	
	newGroup userList isNil
		ifTrue: [newGroup userList: OrderedCollection new].
	subject addGroup: newGroup.
		
	^newGroup.
	! !

!OcGroup methodsFor: 'adding' stamp: 'RFG 5/13/2013 15:58'!
addUser: anId
	"Adds a user into the group."

	userList add: anId! !

!OcGroup methodsFor: 'deletion' stamp: 'RFG 5/13/2013 19:01'!
delete
	"Removes a group from the system."

	| subject
	  sys
	  subjectId
	  groupId   |
	
	groupId := self id.
	subjectId := self subject.
	userList do:[:user |
		user leaveGroup: groupId.
		].
	sys := System create.
	subject := sys findSubject: subjectId.
	subject groupTable removeKey: groupId.! !

!OcGroup methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 16:48'!
initialize
	
	super initialize.
	userList = OrderedCollection new.! !

!OcGroup methodsFor: 'accessing' stamp: 'RFG 5/11/2013 11:10'!
instructor
	"Returns the group's instructor."

	^instructor.! !

!OcGroup methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:09'!
instructor: anUserId
	"Sets the group's instructor."

	instructor := anUserId.! !

!OcGroup methodsFor: 'remotion' stamp: 'RFG 5/13/2013 19:29'!
removeUser: anId
	"Removes the user with the given ID."
	
	| userId 
	  user 
	  system |
	
	userId := userList removeAt: anId.
	system := System create.
	user := system findUser: userId.
	user groupList remove: (self id).
	! !

!OcGroup methodsFor: 'accessing' stamp: 'RFG 5/11/2013 11:10'!
subject
	"Returns the group's subject."

	^subject.! !

!OcGroup methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:09'!
subject: anSubjectId
	"Sets the group's subject."

	subject := anSubjectId.! !

!OcGroup methodsFor: 'accessing' stamp: 'RFG 5/11/2013 10:54'!
userList
	"Returns the list of inscribed users."

	^userList.! !

!OcGroup methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:09'!
userList: aListOfIds
	"Sets the list of inscribed users."

	userList := aListOfIds.! !

DidaticStructure subclass: #Subject
	instanceVariableNames: 'groupTable lectureTable responsible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Undergrad'!

!Subject commentStamp: 'RFG 5/6/2013 15:55' prior: 0!
Represents a Subject in the system.!

!Subject class methodsFor: 'instance creation' stamp: 'RFG 5/13/2013 15:14'!
newNamed: aName withId: anId by: anUserId onTopic: aTopicId

	"Creates a new Subject managed by a teacher responsible. "

	| newSubject |
	
	newSubject := self newNamed: aName withId: anId by: anUserId onTopic: aTopicId managedBy: anUserId.
	
	^newSubject.! !

!Subject class methodsFor: 'instance creation' stamp: 'RFG 5/13/2013 15:17'!
newNamed: aName withId: anId by: anUserId onTopic: aTopicId managedBy: responsibleId
	"Creates a new Subject managed by a teacher responsible. "

	| newSubject 
	  topic
	  sys             |
	
	newSubject := super newNamed: aName withId: anId by: anUserId onTopic: aTopicId.
	newSubject responsible: responsibleId.
	
	newSubject groupTable isNil
		ifTrue: [newSubject groupTable: Dictionary new].
	
	newSubject lectureTable isNil
		ifTrue: [newSubject lectureTable: Dictionary new].
		
	sys := System create.
	
	topic := sys findTopic: aTopicId.
	topic addSubject: newSubject.
	
	^newSubject.! !

!Subject methodsFor: 'adding' stamp: 'RFG 5/13/2013 14:25'!
addGroup: aGroup
	"Adds the group to the subject list."

	groupTable at: aGroup id put: aGroup.! !

!Subject methodsFor: 'adding' stamp: 'RFG 5/13/2013 14:28'!
addLecture: aLecture
	"Adds the lecture to the subject list."

	groupTable at: aLecture id put: aLecture.! !

!Subject methodsFor: 'deletion' stamp: 'RFG 5/13/2013 19:51'!
delete
	"Removes the subject from the system."
	
	| system
	  topic    |
	
	groupTable do: [:group | group delete.].
	lectureTable do: [:lecture| lecture delete].
	
	system := System create.
	topic := system findTopic: (self topic).
	topic subjectTable removeAt: (self id).! !

!Subject methodsFor: 'accessing' stamp: 'RFG 5/13/2013 19:03'!
findGroup: anGroupId
	"Returns a group at id if present."

	^(groupTable at: anGroupId).! !

!Subject methodsFor: 'accessing' stamp: 'RFG 5/13/2013 19:04'!
findLecture: anLectureId
	"Returns a lecture at if present."

	^(lectureTable at: anLectureId).! !

!Subject methodsFor: 'accessing' stamp: 'RFG 5/12/2013 09:13'!
groupTable
	"Returns the table of groups that study this discipline."

	^groupTable.! !

!Subject methodsFor: 'accessing' stamp: 'RFG 5/12/2013 09:13'!
groupTable: aDict
	"Sets the table of groups that study this discipline."

	groupTable := aDict.! !

!Subject methodsFor: 'accessing' stamp: 'RFG 5/13/2013 14:30'!
lectureTable
	"Returns the table of lectures that of this discipline."

	^lectureTable.! !

!Subject methodsFor: 'accessing' stamp: 'RFG 5/13/2013 14:29'!
lectureTable: aDict
	"Sets the table of lectures of this discipline."

	lectureTable := aDict.! !

!Subject methodsFor: 'remotion' stamp: 'RFG 5/13/2013 19:00'!
removeGroup: aGroupId
	"Removes the user with the given ID"
	
	| group |
	group := self findGroup: aGroupId.
	group delete.! !

!Subject methodsFor: 'remotion' stamp: 'RFG 5/13/2013 19:04'!
removeLecture: aLectureId
	"Removes the lecture with the given ID"
	
	| lecture |
	lecture := self findLecture: aLectureId.
	lecture delete.! !

!Subject methodsFor: 'accessing' stamp: 'RFG 5/12/2013 09:14'!
responsible
	"Returns the teacher responsible for this subject."

	^responsible.! !

!Subject methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:11'!
responsible: anUserId
	"Sets the teacher responsible for this subject."

	responsible := anUserId.! !

DidaticStructure subclass: #Topic
	instanceVariableNames: 'courseTable subjectTable moderatorList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Undergrad'!

!Topic commentStamp: 'RFG 5/2/2013 13:44' prior: 0!
Represents a topic in the system.!

!Topic class methodsFor: 'instance creation' stamp: 'AP 5/12/2013 19:53'!
newNamed: aName withId: anId by: anUserId
	"Creates a new topic with the given name and id."
	
	|newTopic
	 sys		|
	
	newTopic := super newNamed: aName withId: anId by: anUserId onTopic: anId .
	
	newTopic courseTable isNil
		ifTrue: [newTopic courseTable: Dictionary new].
		
	newTopic subjectTable isNil
		ifTrue: [newTopic subjectTable: Dictionary new].
	
	newTopic moderatorList isNil
		ifTrue: [newTopic moderatorList: OrderedCollection new].
		
	sys := System create.
	sys addTopic: newTopic.
	
	^newTopic.! !

!Topic methodsFor: 'adding' stamp: 'AP 5/11/2013 23:34'!
addCourse: aCourse

	courseTable at: aCourse id put: aCourse.

	! !

!Topic methodsFor: 'adding' stamp: 'AP 5/12/2013 20:54'!
addModerator: aModeratorId

	moderatorList add: aModeratorId.! !

!Topic methodsFor: 'adding' stamp: 'RFG 5/13/2013 13:09'!
addSubject: aSubject
	"Adds the subject to the subject list."

	subjectTable at: aSubject id put: aSubject.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 11:16'!
courseTable
	"Returns the dictionary of courses of the topic."

	^courseTable.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 11:17'!
courseTable: aDictionary
	"Sets the dictionary of courses of the topic."

	courseTable := aDictionary.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/5/2013 08:50'!
creator
	"Returns the topic creator."

	^creator.! !

!Topic methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:28'!
creator: anUserId.
	"Sets the topic creator."

	creator := anUserId.! !

!Topic methodsFor: 'deletion' stamp: 'RFG 5/13/2013 19:52'!
delete
	"Removes the topic from the system."
	
	| system
	  topic    |
	
	courseTable do: [:course | course delete.].
	subjectTable do: [:subject| subject delete].
	
	system := System create.
	topic := system findTopic: (self topic).
	system removeTopic: (self id).! !

!Topic methodsFor: 'accessing' stamp: 'AP 5/12/2013 15:25'!
findCourse: aCourseId

	^courseTable at: aCourseId ifAbsent:[^nil].! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/13/2013 14:12'!
findSubject: aSubjectId

	^subjectTable at: aSubjectId ifAbsent:[^nil].! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/13/2013 12:55'!
id
	"Returns the topic id."

	^id.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/13/2013 12:56'!
id: anId
	"Sets the topic id."

	id := anId.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 15:44'!
moderatorList
	"Returns the list of moderators of the topic."

	^moderatorList.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 15:43'!
moderatorList: anOrderedCollection
	"Sets the list of moderators of the topic."

	moderatorList := anOrderedCollection.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 11:15'!
name
	"Returns the topic name."

	^name.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 11:15'!
name: aName.
	"Sets the topic name."

	name := aName.! !

!Topic methodsFor: 'remotion' stamp: 'RFG 5/13/2013 19:43'!
removeCourse: aCourseId
	"Removes the course with the given ID"
	
	| course |
	course := self findGroup: aCourseId.
	course delete.! !

!Topic methodsFor: 'remotion' stamp: 'RFG 5/13/2013 19:45'!
removeSubject: aSubjectId
	"Removes the subject with the given ID"
	
	| subject |
	subject := self findSubject: aSubjectId.
	subject delete.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 15:42'!
subjectTable
	"Returns the dictionary of subjects of the topic."

	^subjectTable.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 15:41'!
subjectTable: aDictionary
	"Sets the dictionary of subjects of the topic."

	subjectTable := aDictionary.! !

Object subclass: #FakeFile
	instanceVariableNames: 'title contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!FakeFile methodsFor: 'accessing' stamp: 'jsa 5/11/2013 16:50'!
contents
	"Answer the value of contents"

	^ contents! !

!FakeFile methodsFor: 'accessing' stamp: 'jsa 5/11/2013 16:50'!
contents: anObject
	"Set the value of contents"

	contents := anObject! !

!FakeFile methodsFor: 'accessing' stamp: 'jsa 5/11/2013 16:50'!
title
	"Answer the value of title"

	^ title! !

!FakeFile methodsFor: 'accessing' stamp: 'jsa 5/11/2013 16:50'!
title: anObject
	"Set the value of title"

	title := anObject! !

Object subclass: #MaterialManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!MaterialManager methodsFor: 'private' stamp: 'Su 5/12/2013 21:55'!
createMaterialURL: aMaterial
	| numberOfMaterialsWithSameAuthorAndTitle|
	 numberOfMaterialsWithSameAuthorAndTitle := (Data materialList select: [ : material | material owner = aMaterial owner and: material title = aMaterial title]) size.
	^aMaterial owner email, '/', aMaterial title, ((numberOfMaterialsWithSameAuthorAndTitle = 0) ifTrue:[''] ifFalse:['_', numberOfMaterialsWithSameAuthorAndTitle]).
	! !

!MaterialManager methodsFor: 'management' stamp: 'jsa 5/13/2013 15:18'!
editMaterial: anEditedMaterial
	| materialToEdit |
	materialToEdit := Data materialList like: anEditedMaterial.
	materialToEdit ifNotNil: [
		(UserManager new canEditMaterial: materialToEdit owner)
			ifFalse: [Error signal: 'User doesn''t have permission to edit this material'].
	
		anEditedMaterial title ifNotNil: [materialToEdit title: anEditedMaterial title].
		anEditedMaterial description ifNotNil: [materialToEdit description: anEditedMaterial description].
		anEditedMaterial authors ifNotNil: [materialToEdit authors: anEditedMaterial authors].
		anEditedMaterial file ifNotNil: [materialToEdit file: anEditedMaterial file].
		anEditedMaterial tags ifNotNil: [materialToEdit tags: anEditedMaterial tags].
		anEditedMaterial type ifNotNil: [materialToEdit type: anEditedMaterial type].
		anEditedMaterial licence ifNotNil: [materialToEdit licence: anEditedMaterial licence].
	]! !

!MaterialManager methodsFor: 'private' stamp: 'jsa 5/11/2013 18:21'!
materialList
	^ Data materialList! !

!MaterialManager methodsFor: 'management' stamp: 'jsa 5/13/2013 15:14'!
removeMaterial: aUrl
	| materialToRemove |
	materialToRemove := Data materialList like: (DidacticMaterial new url: aUrl).
	(UserManager new canRemoveMaterial: materialToRemove owner)
		ifFalse: [Error signal: 'User doesn''t have permission to remove this material'].
	Data materialList remove: materialToRemove.! !

!MaterialManager methodsFor: 'searching' stamp: 'jsa 5/11/2013 19:35'!
search: aDidacticMaterialSearchSpecs
	^ Data materialList select: [ :material | aDidacticMaterialSearchSpecs matches: material]! !

!MaterialManager methodsFor: 'management' stamp: 'Su 5/12/2013 21:42'!
submitMaterial: submittedFile title: title authors: authorsList description: description type: type licence: licence tags: tags
	| material now user|
	now := TimeStamp now.
	user := Session user.
	UserManager new canSubmitMaterial ifTrue: [
	material := DidacticMaterial new file: submittedFile; title: title; authors: authorsList; description: description; type: type; licence: licence; tags: tags; creationDate: now; lastUploadDate: now; owner: user.
	material url: (self createMaterialURL: material).
	Data materialList add: material]
	ifFalse: [Error signal: 'User doesn''t have permission to submit material']! !

Object subclass: #OcDatabase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcDatabase methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:14'!
connect

	^ true! !

!OcDatabase methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:14'!
connectionFailed

	^ false! !

!OcDatabase methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:14'!
disconnect

	^ true! !

OcDatabase subclass: #OcImageDatabase
	instanceVariableNames: ''
	classVariableNames: 'Groups Users WriteMutex'
	poolDictionaries: ''
	category: 'OpenCourses'!

OcImageDatabase class
	instanceVariableNames: 'Users'!

OcImageDatabase class
	instanceVariableNames: 'Users'!

!OcImageDatabase class methodsFor: 'accessing' stamp: 'cmb 6/28/2013 16:50'!
groups
	^ Groups ifNil: [Groups := SortedCollection new].  ! !

!OcImageDatabase class methodsFor: 'accessing' stamp: 'cmb 6/28/2013 16:49'!
groups: anObject
	Groups := anObject! !

!OcImageDatabase class methodsFor: 'accessing' stamp: 'cmb 6/25/2013 22:45'!
users
	^ Users ifNil: [Users := OrderedCollection new]! !

!OcImageDatabase class methodsFor: 'accessing' stamp: 'cmb 6/25/2013 22:44'!
users: anObject
	Users := anObject! !

!OcImageDatabase class methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 23:04'!
writeMutex
 
	^ WriteMutex ifNil: [WriteMutex := Monitor new]! !

!OcImageDatabase class methodsFor: 'accessing' stamp: 'cmb 6/25/2013 23:04'!
writeMutex: anObject
	WriteMutex := anObject! !

!OcImageDatabase methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:22'!
addUser: aUser

	self class users add: aUser.
 	self saveImage.
 	^ aUser! !

!OcImageDatabase methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:22'!
findUserByEmail: anEmail

	^ self class users
  		detect: [:each | each email = anEmail]
  		ifNone: [nil]! !

!OcImageDatabase methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 10:20'!
findUserByUserName: anUserName

	^ self class users
  		detect: [:each | each userName = anUserName]
  		ifNone: [nil]! !

!OcImageDatabase methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:21'!
saveImage

	self class writeMutex critical: [self saveImageWithoutMonitor]! !

!OcImageDatabase methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:19'!
saveImageWithoutMonitor

	SmalltalkImage current saveSession.! !

Object subclass: #OcDidacticMaterial
	instanceVariableNames: 'file url title authors owner licence creationDate lastUploadDate type tags materialDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcDidacticMaterial methodsFor: 'comparing' stamp: 'cmb 6/28/2013 14:33'!
= aDidacticMaterial
	aDidacticMaterial ifNotNil: [^ aDidacticMaterial url = self url].
	^ false! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
authors
	"Answer the value of authors"

	^ authors! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
authors: anObject
	"Set the value of authors"

	authors := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
creationDate
	"Answer the value of creationDate"

	^ creationDate! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
creationDate: anObject
	"Set the value of creationDate"

	creationDate := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
file
	"Answer the value of file"

	^ file! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
file: anObject
	"Set the value of file"

	file := anObject! !

!OcDidacticMaterial methodsFor: 'comparing' stamp: 'cmb 6/28/2013 14:33'!
hash
	^ self url hash! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
lastUploadDate
	"Answer the value of lastUploadDate"

	^ lastUploadDate! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
lastUploadDate: anObject
	"Set the value of lastUploadDate"

	lastUploadDate := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
licence
	"Answer the value of licence"

	^ licence! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
licence: anObject
	"Set the value of licence"

	licence := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
materialDescription
	"Answer the value of description"

	^ materialDescription! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
materialDescription: anObject
	"Set the value of description"

	materialDescription := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
owner
	"Answer the value of owner"

	^ owner! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
owner: anObject
	"Set the value of owner"

	owner := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
tags
	"Answer the value of tags"

	^ tags! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
tags: anObject
	"Set the value of tags"

	tags := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
title
	"Answer the value of title"

	^ title! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
title: anObject
	"Set the value of title"

	title := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
type
	"Answer the value of type"

	^ type! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
type: anObject
	"Set the value of type"

	type := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
url
	"Answer the value of url"

	^ url! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
url: anObject
	"Set the value of url"

	url := anObject! !

Object subclass: #OcUser
	instanceVariableNames: 'id password email userName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcUser class methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 23:36'!
hashPassword: aString

	^ aString 
  		ifEmpty: [0] 
  		ifNotEmpty: [GRPlatform current secureHashFor: aString].! !

!OcUser methodsFor: 'accessing' stamp: 'cmb 5/10/2013 16:30'!
email
	"Answer the value of email"

	^ email! !

!OcUser methodsFor: 'accessing' stamp: 'cmb 5/10/2013 16:30'!
email: anObject
	"Set the value of email"

	email := anObject! !

!OcUser methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:34'!
id
	^ id! !

!OcUser methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:34'!
id: anObject
	id := anObject! !

!OcUser methodsFor: 'checking' stamp: 'cmb 5/13/2013 00:13'!
isLogged
	^ Session user = self.! !

!OcUser methodsFor: 'accessing' stamp: 'cmb 5/10/2013 16:30'!
password
	"Answer the value of password"

	^ password! !

!OcUser methodsFor: 'accessing' stamp: 'cmb 5/10/2013 16:30'!
password: anObject
	"Set the value of password"

	password := anObject! !

!OcUser methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:35'!
userName
	"Answer the value of name"
	^ userName! !

!OcUser methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:35'!
userName: anObject
	"Set the value of name"

	userName := anObject! !

Object subclass: #Session
	instanceVariableNames: ''
	classVariableNames: 'CurrentUser'
	poolDictionaries: ''
	category: 'OpenCourses'!

!Session class methodsFor: 'accessing' stamp: 'cmb 5/10/2013 18:58'!
user
	^CurrentUser! !

!Session class methodsFor: 'accessing' stamp: 'cmb 5/10/2013 18:58'!
user: aUser
	CurrentUser := aUser! !

Object subclass: #System
	instanceVariableNames: 'TopicTable TopicToBeAproved UserTable'
	classVariableNames: 'Id Single'
	poolDictionaries: ''
	category: 'OpenCourses-Undergrad'!

!System commentStamp: 'RFG 5/2/2013 13:21' prior: 0!
The main class representing the own system.!

!System class methodsFor: 'initialization' stamp: 'RFG 5/13/2013 15:08'!
create
	"Creates an empty system."
	
	Single isNil
		ifTrue: [
			Single := self new.
			Single TopicTable: Dictionary new.
			Single UserTable: Dictionary new.
			Single TopicToBeAproved:  OrderedCollection new.
			].
		^Single.! !

!System class methodsFor: 'id management' stamp: 'RFG 5/13/2013 20:12'!
nextId
	"Returns the next id avaliable."

	Id isNil
		ifTrue:[Id := 0]
		ifFalse:[Id := Id + 1].
	^Id.! !

!System class methodsFor: 'initialization' stamp: 'RFG 5/13/2013 15:11'!
reset
	"Re-creates an empty system."
	
	| newSys |
	Single := nil.
	newSys := System create.
	^newSys.
	
	! !

!System methodsFor: 'accessing' stamp: 'RFG 5/3/2013 20:54'!
TopicTable
	"Returns the dictionary with all topics."

	^TopicTable.! !

!System methodsFor: 'accessing' stamp: 'RFG 5/3/2013 20:54'!
TopicTable: aDictionary
	"Sets the dictionary with all topics."

	TopicTable :=  aDictionary! !

!System methodsFor: 'accessing' stamp: 'RFG 5/13/2013 15:05'!
TopicToBeAproved: aCollection
	"Sets the orderedCollection with all topics that aren't aproved yet."

	^TopicToBeAproved :=  aCollection! !

!System methodsFor: 'accessing' stamp: 'RFG 5/3/2013 20:17'!
UserTable
	"Returns the dictionary with all users."

	^UserTable.! !

!System methodsFor: 'accessing' stamp: 'RFG 5/3/2013 20:13'!
UserTable: aDictionary
	"Sets the system user table."

	UserTable := aDictionary.! !

!System methodsFor: 'adding' stamp: 'RFG 5/13/2013 13:03'!
addTopic: aTopic

	TopicTable at: aTopic id put: aTopic.
	TopicToBeAproved addLast: aTopic id.! !

!System methodsFor: 'adding' stamp: 'RFG 5/13/2013 13:03'!
addUser: anUser

	UserTable at: anUser id put: anUser  .! !

!System methodsFor: 'accessing' stamp: 'RFG 5/13/2013 13:53'!
findCourse: anId
	"Returns a course with the given ID."
	
	| anArray
	  aTopic
	  aCourse
	  index   |
	
	index := 1.
	anArray := TopicTable associations.
	[index <= anArray size]
	whileTrue: [
		aTopic := anArray at: index.
		aCourse := aTopic value findCourse: anId.
		aCourse notNil
		ifTrue:[
			^aCourse
			].
		index := index +1
		].
		^(KeyNotFound key: anId) signal.! !

!System methodsFor: 'accessing' stamp: 'RFG 5/13/2013 14:08'!
findGroup: anId
	"Returns a group with the given ID."
	
	|isThere group|
	TopicTable do:  [:topic |
		topic subjectTable do: [:subject |
			isThere := subject groupTable includesKey: anId.
			isThere ifTrue:[
				group := subject groupTable at: anId]
		].
	].
	group isNil 
		ifTrue:[^(KeyNotFound key: anId) signal.]
		ifFalse:[^group].
	! !

!System methodsFor: 'accessing' stamp: 'RFG 5/13/2013 21:47'!
findLecture: anId
	"Returns a lecture with the given ID."
	
	|isThere  
	lecture   |
	TopicTable do:  [:topic |
		topic subjectTable do: [:subject |
			isThere := subject lectureTable includesKey: anId.
			isThere ifTrue:[
				 lecture := subject lectureTable at: anId]
		].
	].
	 lecture isNil 
		ifTrue:[^(KeyNotFound key: anId) signal.]
		ifFalse:[^ lecture].
	! !

!System methodsFor: 'accessing' stamp: 'RFG 5/13/2013 14:13'!
findSubject: anId
	"Returns a subject with the given ID."
	
	| anArray
	  aTopic
	  aSubject
	  index     |
	
	index := 1.
	anArray := TopicTable associations.
	[index <= anArray size]
	whileTrue: [
		aTopic := anArray at: index.
		aSubject := aTopic value findSubject: anId.
		aSubject notNil
		ifTrue:[
			^aSubject
			].
		index := index +1
		].
		^(KeyNotFound key: anId) signal.! !

!System methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:13'!
findTopic: anId

	^TopicTable at: anId! !

!System methodsFor: 'accessing' stamp: 'AP 5/12/2013 21:13'!
findUser: anId

	^UserTable at: anId! !

!System methodsFor: 'removing' stamp: 'AP 5/12/2013 21:27'!
removeTopic: anId
	"Remove a Topic from the System"
	TopicTable removeKey: anId! !

!System methodsFor: 'removing' stamp: 'AP 5/12/2013 21:27'!
removeUser: anId
	"Remove an user from the System"
	UserTable removeKey: anId! !

!System methodsFor: 'accessing' stamp: 'AP 5/11/2013 21:53'!
topicToModerator
	"Gives a topic for the moderator analysis"
	^TopicToBeAproved at: 1! !

Object subclass: #User
	instanceVariableNames: 'id name courseList groupList contentList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Undergrad'!

!User commentStamp: 'RFG 5/2/2013 11:22' prior: 0!
Represents a user in the system.!

User subclass: #Moderator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Undergrad'!

!Moderator commentStamp: 'RFG 5/11/2013 12:24' prior: 0!
Represents a topic moderator in the system.!

Moderator subclass: #Administrator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Undergrad'!

!Administrator commentStamp: 'RFG 5/11/2013 14:52' prior: 0!
Represents special users who can create topics and erase/create anything.!

!Administrator methodsFor: 'creation' stamp: 'RFG 5/13/2013 12:38'!
createTopic: aName withId: anId by: userId

	| sys
	  aTopic|
	
	aTopic := Topic  newNamed: aName withId: anId by: userId.
	sys := System create.
	sys addTopic: aTopic.! !

!Administrator methodsFor: 'creation' stamp: 'AP 5/12/2013 20:38'!
createTopic: aName withId: anId created: userId

	| sys
	  aTopic|
	
	aTopic := Topic  newNamed: aName withId: anId by: userId.
	sys := System create.
	sys addTopic: aTopic.! !

!Administrator methodsFor: 'creation' stamp: 'RFG 5/13/2013 16:03'!
createUser: aName withId: anId
	
	| newUser 
	  sys        |
	
	newUser := User newNamed: aName withId: anId.
	sys := System create.
	sys addUser: newUser.! !

!Administrator methodsFor: 'nominate' stamp: 'RFG 5/13/2013 20:33'!
nominateAdministrator: anUser
	"Give moderator privileges to an user"

	| newAdministrator
	  sys			      |
	
	newAdministrator := Administrator newNamed: anUser name withId: anUser id.
	newAdministrator courseList: anUser courseList. 
	newAdministrator groupList: anUser groupList.
	newAdministrator contentList: anUser contentList.
	
	sys := System create.
	sys removeUser: anUser id.
	sys addUser: newAdministrator id.
	
	^newAdministrator.! !

!Administrator methodsFor: 'nominate' stamp: 'RFG 5/13/2013 20:29'!
nominateModerator: anUser onTopic: aTopicId
	"Give moderator privileges to an user"

	| newModerator 
	  sys			
	  aTopic		|
	
	newModerator := Moderator newNamed: anUser name withId: anUser id.
	newModerator courseList: anUser courseList. 
	newModerator groupList: anUser groupList.
	newModerator contentList: anUser contentList.
	
	sys := System create.
	sys removeUser: anUser id.
	sys addUser: newModerator.
	
	aTopic := sys findTopic: aTopicId.
	aTopic addModerator: newModerator id.
	
	^newModerator.! !

!Moderator methodsFor: 'publishing' stamp: 'AP 5/11/2013 21:55'!
aproveTopic
	"Make a topic visible for the public. In other words, the moderator aproves a topic
	using this function"
	| anId
	  aTopic
	  sys	|
	
	sys := System create.
	anId := sys topicToModerator.
	aTopic := sys findTopic: anId.
	aTopic visible: true.
! !

!Moderator methodsFor: 'publishing' stamp: 'RFG 5/13/2013 21:11'!
hide: aDidaticStructure
	"Turns a didatic structure invisible to all common users non-owners."

	| topic 
	  system 
	  mod     |
	
	system := System create.
	topic :=  system findTopic: aDidaticStructure topic.
	
	mod := topic moderatorList at: self id.
	mod isNil
		ifFalse:[aDidaticStructure visible: True].
		! !

!Moderator methodsFor: 'publishing' stamp: 'RFG 5/13/2013 20:36'!
publish: aDidaticStructure
	"Turns a didatic structure invisible to all commom users non-owners."

	| topic 
	  system
	  mod     |
	
	system := System create.
	topic :=  system findTopic: aDidaticStructure topic.
	
	mod := topic moderatorList at: self id.
	mod isNil
		ifFalse:[aDidaticStructure visible: True].! !

!User class methodsFor: 'instance creation' stamp: 'AP 5/12/2013 19:58'!
newNamed: aName withId: anId
	"comment stating purpose of message"
	
	|newUser
	 sys	   |
		
	newUser := self new.
	newUser id: anId.
	newUser name: aName.
	newUser groupList isNil
		ifTrue: [newUser groupList: OrderedCollection new].
	newUser courseList isNil
		ifTrue: [newUser courseList: OrderedCollection new].
	newUser contentList isNil
		ifTrue: [newUser contentList: OrderedCollection new].
		
	sys := System create.
	sys addUser: newUser.
	^newUser! !

!User methodsFor: 'accessing' stamp: 'RFG 5/3/2013 16:31'!
contentList
	"Returns a list with the IDs of the Contents owned by the user."

	^contentList.! !

!User methodsFor: 'accessing' stamp: 'RFG 5/3/2013 18:15'!
contentList: anOrderedCollection
	"Sets the user content list."

	contentList := anOrderedCollection.! !

!User methodsFor: 'accessing' stamp: 'RFG 5/3/2013 16:39'!
courseList
	"comment stating purpose of message"

	^courseList.! !

!User methodsFor: 'accessing' stamp: 'RFG 5/3/2013 18:19'!
courseList: anOrderedCollection
	"Sets the user content list."

	courseList := anOrderedCollection.! !

!User methodsFor: 'deletion' stamp: 'RFG 5/13/2013 20:02'!
delete
	"Removes the user from the system."
	| sys |
	sys := System create.
	sys  removeUser: self Id.
	courseList do: [: course| course removeUser: (self id).].
	groupList do:[:group | group removeUser: (self id).].
	! !

!User methodsFor: 'remotion' stamp: 'RFG 5/12/2013 08:25'!
delete: aDidaticStructure
	"Tries to delete a structure."

	aDidaticStructure ownerList remove: id ifAbsent: [Transcript show: 'User can not do that.'].
	aDidaticStructure delete.! !

!User methodsFor: 'subscription' stamp: 'AP 5/13/2013 13:52'!
enrollCourse: courseId
	"Enrolls the user in a course and register this course in the courselist."
	
	| sys
	  aCourse |
	
	self courseList add: courseId.
	sys := System create.
	aCourse := sys findCourse: courseId.
	aCourse addUser: self Id.! !

!User methodsFor: 'subscription' stamp: 'AP 5/12/2013 21:30'!
enterGroup: aGroupId
	"Makes the user part of the group with the given ID."! !

!User methodsFor: 'accessing' stamp: 'RFG 5/3/2013 16:30'!
groupList
	"Returns a list with the IDs of the Groups which the user is in."

	^groupList.! !

!User methodsFor: 'accessing' stamp: 'RFG 5/3/2013 18:16'!
groupList: anOrderedCollection
	"Sets the user group list."

	groupList := anOrderedCollection.! !

!User methodsFor: 'accessing' stamp: 'RFG 5/13/2013 13:00'!
id
	"Returns the user ID."

	^id.! !

!User methodsFor: 'accessing' stamp: 'RFG 5/13/2013 13:01'!
id: anId
	"comment stating purpose of message"

	id := anId.! !

!User methodsFor: 'subscription' stamp: 'RFG 5/13/2013 19:29'!
leaveGroup: aGroupId
	"Makes user leave a group."
	
	| group  
	system |
	
	system := System create.
	group := system findGroup: aGroupId. 
	group removeUser: id.
	groupList remove: aGroupId.! !

!User methodsFor: 'accessing' stamp: 'RFG 5/3/2013 15:32'!
name
	"Returns the user's name."

	^name.! !

!User methodsFor: 'accessing' stamp: 'RFG 5/3/2013 15:17'!
name: aName
	"comment stating purpose of message"

	name := aName.! !

!User methodsFor: 'subscription' stamp: 'RFG 5/13/2013 21:48'!
watchLecture: aLectureId
	"Includes the user on the list of user who watched a class."

	| lecture |
	lecture := System findLecture: aLectureId.
	lecture userList add: (self id).! !

!User methodsFor: 'subscription' stamp: 'RFG 5/13/2013 19:34'!
withdrawCourse: aCourseId
	"comment stating purpose of message"
	
	| course 
	system  |
	
	system := System create.
	course := system findCourse: aCourseId. 
	course userList remove: id.
	courseList remove: aCourseId.! !

Object subclass: #UserManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!UserManager methodsFor: 'permission' stamp: 'Su 5/13/2013 16:48'!
canChangeUserEmail: anUser
	Session user ifNotNil:
		[^ (Session user = anUser) or: (Session user = Data admin)].
	^ false
	! !

!UserManager methodsFor: 'permission' stamp: 'jsa 5/13/2013 17:51'!
canChangeUserName: anUser
	Session user ifNotNil:
		[^ (Session user = anUser) or: (Session user = Data admin)].
	^ false
	! !

!UserManager methodsFor: 'permission' stamp: 'Su 5/13/2013 17:44'!
canChangeUserPassword: anUser
	Session user ifNotNil:
		[^ (Session user = anUser) or: (Session user = Data admin)].
	^ false
	! !

!UserManager methodsFor: 'permission' stamp: 'Su 5/13/2013 16:24'!
canEditMaterial: userOwner
	Session user ifNotNil:
		[^ (Session user = userOwner) or: (Session user = Data admin)].
	^ false
	! !

!UserManager methodsFor: 'permission' stamp: 'Su 5/13/2013 16:24'!
canRemoveMaterial: userOwner
	Session user ifNotNil:
		[^ Session user = userOwner or: (Session user = Data admin)].
	^ false
	! !

!UserManager methodsFor: 'permission' stamp: 'jsa 5/13/2013 19:25'!
canRemoveUser: userToRemove
	Session user ifNotNil:
		[^ Session user = userToRemove or: (Session user = Data admin)].
	^ false
	! !

!UserManager methodsFor: 'permission' stamp: 'jsa 5/11/2013 18:44'!
canSubmitMaterial
	^ (Session user isNil) not! !

!UserManager methodsFor: 'editing' stamp: 'cmb 6/25/2013 21:35'!
changeEmail: user newEmail: newEmail
	(Data userList includes: (OcUser new email: newEmail))
		ifTrue: [Error signal: 'email already used by another user.']
		ifFalse: [
			(self canChangeUserEmail: user) ifTrue: [
				self registerNewUser: user name password: user password email: newEmail.
				Data userList remove: user.
				(Session user = user) ifTrue: [
				Session user: (Data userList like: (OcUser new email: newEmail)).
				]] ifFalse: [Error signal: 'User doesn''t have permission to change this email.']]
		


! !

!UserManager methodsFor: 'editing' stamp: 'jsa 5/13/2013 17:51'!
changeName: anUser newName: newName
	| registeredUser |
	(self canChangeUserName: anUser) ifTrue: [
		registeredUser := Data userList like: anUser.
		registeredUser name: newName.
	] ifFalse: [
		Error signal: 'User doesn''t have permission to change this name.'
	]
		! !

!UserManager methodsFor: 'editing' stamp: 'Su 5/13/2013 17:44'!
changePassword: anUser newPassword: newPassword
	(self canChangeUserPassword: anUser) ifTrue: [
		anUser password: newPassword.
		] 
	ifFalse: [
		Error signal: 'User doesn''t have permission to change this password.'
		]
		! !

!UserManager methodsFor: 'private' stamp: 'jsa 5/11/2013 18:21'!
hasUser: aUser 
	^ Data userList includes: aUser! !

!UserManager methodsFor: 'authentication' stamp: 'cmb 6/25/2013 21:35'!
login: email password: password 
	| user registeredUser | 
	Data admin ifNil: [(email = 'admin' and: password = 'admin') ifTrue: [self registerDefaultAdmin]].
	user := OcUser new email: email;
				 password: password.
	registeredUser := Data userList
				like: user
				ifAbsent: [Error signal: 'User/Password incorrect!!'].
	user password = registeredUser password
		ifTrue: [Session user: registeredUser]
		ifFalse: [Error signal: 'User/Password incorrect!!']! !

!UserManager methodsFor: 'authentication' stamp: 'cmb 5/13/2013 19:22'!
logoff
	Session user: nil.! !

!UserManager methodsFor: 'managing' stamp: 'cmb 6/25/2013 21:35'!
registerDefaultAdmin
	self registerNewUser: 'admin' password: 'admin' email: 'admin'.
	Data admin: (Data userList like: (OcUser new email: 'admin')). ! !

!UserManager methodsFor: 'managing' stamp: 'cmb 6/25/2013 21:35'!
registerNewUser: name password: password email: email 
	| newUser |
	newUser := OcUser new name: name;
				 password: password;
				 email: email.
	(Data userList includes: newUser)
		ifFalse: [Data userList add: newUser]
		ifTrue: [Error signal: 'Duplicated user']! !

!UserManager methodsFor: 'managing' stamp: 'jsa 5/13/2013 19:26'!
removeUser: anUser
	| userToRemove |
	userToRemove := Data userList like: anUser.
	(UserManager new canRemoveUser: userToRemove)
		ifFalse: [Error signal: 'User doesn''t have permission to remove this user'].
	Data userList remove: userToRemove.
	(Session user = anUser) ifTrue: [
		self logoff
	]! !

!UserManager methodsFor: 'private' stamp: 'Su 5/13/2013 16:21'!
userList
	"Answer the value of userList"

	^Data userList! !

WASession subclass: #OcSession
	instanceVariableNames: 'user database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcSession methodsFor: 'accessing' stamp: 'cmb 6/25/2013 22:26'!
database
	^ database! !

!OcSession methodsFor: 'accessing' stamp: 'cmb 6/25/2013 22:26'!
database: anObject
	database := anObject! !

!OcSession methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 11:07'!
findUser: anUserName email: anEmail
	
	| userByEmail userByUserName |
	userByEmail := self database findUserByEmail: anEmail.
	userByUserName := self database findUserByUserName: anUserName.
	userByEmail ifNil: [^userByUserName].
	^userByEmail.
		
	

	! !

!OcSession methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:27'!
findUserByEmail: anEmail

	^ self database findUserByEmail: anEmail! !

!OcSession methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 10:15'!
findUserByUserName: anUserName

	^ self database findUserByUserName: anUserName! !

!OcSession methodsFor: 'initialization' stamp: 'cmb 6/25/2013 22:27'!
initialize
 
	super initialize.
	self database: OcImageDatabase new.! !

!OcSession methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:05'!
isLoggedIn 
	^ self user notNil.! !

!OcSession methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:03'!
login: aUser
	self user: aUser.  ! !

!OcSession methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:04'!
logout
	self user: nil.  ! !

!OcSession methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:28'!
responseForRequest: aRequest

	self database connectionFailed
  		ifTrue: [^ WAResponse new nextPutAll: 'No Database Connection'].
	^ super responseForRequest: aRequest! !

!OcSession methodsFor: 'parent/child' stamp: 'cmb 6/25/2013 22:27'!
unregistered

	self database disconnect.
	super unregistered.! !

!OcSession methodsFor: 'updating' stamp: 'cmb 6/25/2013 22:12'!
updateRoot: anHtmlRoot

	super updateRoot: anHtmlRoot.
 	anHtmlRoot title: OcLibrary applicationName.! !

!OcSession methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:02'!
user
	^ user! !

!OcSession methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:02'!
user: anObject
	user := anObject! !

TestCase subclass: #MaterialManagerTest
	instanceVariableNames: 'emptyMaterialList nonEmptyMaterialList materialManager authorsList submittedFile tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Tests'!

!MaterialManagerTest methodsFor: 'running' stamp: 'cmb 6/25/2013 21:35'!
setUp
      Data blankData.
	emptyMaterialList := Data materialList copy.
	materialManager := MaterialManager new.
	Session user: (OcUser new email: 'auser@email.com').
	authorsList := OrderedCollection new.
	authorsList add: 'an author1'; add: 'an author2'; add: 'an author3'.
	submittedFile := FakeFile new title: 'a file title'; contents: (ByteArray new).
	tags := SortedCollection new.
	tags add: 'DNA'; add: 'RNA'; add:'Molecular Biology'.
	materialManager submitMaterial: submittedFile title: 'a title' authors: authorsList description: 'a description' type: 'class note' licence: 'GPLv3' tags: tags.
	Session user: (OcUser new email: 'user@email.com').
	authorsList := OrderedCollection new.
	authorsList add: 'author1'; add: 'author2'.
	submittedFile := FakeFile new title: 'file title'; contents: (ByteArray new).
	tags := SortedCollection new.
	tags add: 'OOP'; add: 'Smalltalk'.
	materialManager submitMaterial: submittedFile title: 'title' authors: authorsList description: 'description' type: 'slide show' licence: 'GPLv3' tags: tags.
	nonEmptyMaterialList := Data materialList copy! !

!MaterialManagerTest methodsFor: 'editing' stamp: 'jsa 5/12/2013 18:44'!
testEditMaterialEverythingButTitle
	| newAuthorsList newSubmittedFile newTags |
	Data materialList: nonEmptyMaterialList.
	newAuthorsList := OrderedCollection new add: 'new'; add: 'authors'.
	newSubmittedFile := FakeFile new title: 'new file title'; contents: (ByteArray new).
	newTags := SortedCollection new add: 'new'; add: 'tags'.
	self assert: (materialManager materialList select: [ :material | (material title = 'title'
		and: material description = 'new description'
		and: material authors = newAuthorsList)
		and: material file title = newSubmittedFile title
		and: material tags = newTags
		and: material type = 'code'
		and: material licence = 'GPLv2']) size == 0.
	self assert: (materialManager materialList select: [ :material | material title = 'title' and: material description = 'description']) size == 1.
	(materialManager materialList select: [ :material | material title = 'title'])
		do: [ :material | materialManager editMaterial: (DidacticMaterial new url: material url; description: 'new description';
			authors: newAuthorsList; file: newSubmittedFile; tags: newTags; type: 'code'; licence: 'GPLv2')].
	self assert: (materialManager materialList select: [ :material | material title = 'title' and: material description = 'description']) size == 0.
		self assert: (materialManager materialList select: [ :material | (material title = 'title'
		and: material description = 'new description'
		and: material authors = newAuthorsList)
		and: material file title = newSubmittedFile title
		and: material tags = newTags
		and: material type = 'code'
		and: material licence = 'GPLv2']) size == 1.! !

!MaterialManagerTest methodsFor: 'editing' stamp: 'jsa 5/13/2013 19:41'!
testEditMaterialLoggedAsAdmin
	UserManager new login: 'admin' password: 'admin'.
	Data materialList: nonEmptyMaterialList.
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 1.
	(materialManager materialList select: [ :material | material title = 'title'])
		do: [ :material | materialManager editMaterial: (DidacticMaterial new url: material url; title: 'new title')].
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 0.
	self assert: (materialManager materialList select: [ :material | material title = 'new title']) size == 1.! !

!MaterialManagerTest methodsFor: 'editing' stamp: 'cmb 6/25/2013 21:35'!
testEditMaterialLoggedAsDifferentUser
	Session user: (OcUser new email: 'another_user@somewhere_over_the_rainbow.com').
	Data materialList: nonEmptyMaterialList.
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 1.
	(materialManager materialList select: [ :material | material title = 'title'])
		do: [ :material | self should: [materialManager editMaterial: (DidacticMaterial new url: material url; title: 'new title')] raise: Error].
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 1.
	self assert: (materialManager materialList select: [ :material | material title = 'new title']) size == 0.! !

!MaterialManagerTest methodsFor: 'editing' stamp: 'jsa 5/12/2013 18:33'!
testEditMaterialTitle
	Data materialList: nonEmptyMaterialList.
	self assert: (materialManager materialList select: [ :material | material title = 'new title']) size == 0.
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 1.
	(materialManager materialList select: [ :material | material title = 'title'])
		do: [ :material | materialManager editMaterial: (DidacticMaterial new url: material url; title: 'new title')].
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 0.
	self assert: (materialManager materialList select: [ :material | material title = 'new title' and: material description = 'description']) size == 1.! !

!MaterialManagerTest methodsFor: 'editing' stamp: 'jsa 5/13/2013 14:31'!
testEditMaterialTitleThatDoesntExist
	| numberOfMaterials |
	Data materialList: nonEmptyMaterialList.
	numberOfMaterials := materialManager materialList size.
	self assert: (materialManager materialList select: [ :material | material url = 'inexistent url']) size == 0.
	materialManager editMaterial: (DidacticMaterial new url: 'inexistent url').
	self assert: materialManager materialList size = numberOfMaterials.! !

!MaterialManagerTest methodsFor: 'editing' stamp: 'jsa 5/12/2013 18:52'!
testEditMaterialWithoutLogin
	Data materialList: nonEmptyMaterialList.
	Session user: nil.
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 1.
	(materialManager materialList select: [ :material | material title = 'title'])
		do: [ :material | self should: [materialManager editMaterial: (DidacticMaterial new url: material url; title: 'new title')] raise: Error].
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 1.
	self assert: (materialManager materialList select: [ :material | material title = 'new title']) size == 0.! !

!MaterialManagerTest methodsFor: 'removing' stamp: 'jsa 5/12/2013 16:52'!
testRemoveMaterial
	Data materialList: nonEmptyMaterialList.
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 1.
	(materialManager materialList select: [ :material | material title = 'title'])
		do: [ :material | materialManager removeMaterial: material url].
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 0.! !

!MaterialManagerTest methodsFor: 'removing' stamp: 'jsa 5/13/2013 19:48'!
testRemoveMaterialLoggedAsAdmin
	UserManager new login: 'admin' password: 'admin'.
	Data materialList: nonEmptyMaterialList.
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 1.
	(materialManager materialList select: [ :material | material title = 'title'])
		do: [ :material | materialManager removeMaterial: material url].
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 0.! !

!MaterialManagerTest methodsFor: 'removing' stamp: 'cmb 6/25/2013 21:35'!
testRemoveMaterialLoggedAsDifferentUser
	Session user: (OcUser new email: 'another_user@somewhere_over_the_rainbow.com').
	Data materialList: nonEmptyMaterialList.
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 1.
	(materialManager materialList select: [ :material | material title = 'title'])
		do: [ :material | self should: [materialManager removeMaterial: material url] raise: Error].
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 1.! !

!MaterialManagerTest methodsFor: 'removing' stamp: 'jsa 5/13/2013 14:26'!
testRemoveMaterialThatDoesntExist
	| numberOfMaterials |
	Data materialList: nonEmptyMaterialList.
	numberOfMaterials := materialManager materialList size.
	self assert: (materialManager materialList select: [ :material | material title = 'inexistent title']) size == 0.
	(materialManager materialList select: [ :material | material title = 'inexistent title'])
		do: [ :material | materialManager removeMaterial: material url].
	self assert: materialManager materialList size = numberOfMaterials.! !

!MaterialManagerTest methodsFor: 'removing' stamp: 'jsa 5/12/2013 17:01'!
testRemoveMaterialWithoutLogin
	Session user: nil.
	Data materialList: nonEmptyMaterialList.
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 1.
	(materialManager materialList select: [ :material | material title = 'title'])
		do: [ :material | self should: [materialManager removeMaterial: material url] raise: Error].
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 1.! !

!MaterialManagerTest methodsFor: 'searching' stamp: 'Su 5/12/2013 23:44'!
testSearchByAuthors
	| searchSpecsNoResult searchSpecsWithResult|
	Data materialList: nonEmptyMaterialList.
	authorsList := OrderedCollection new.
	authorsList add: 'wrong author'.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new authors: authorsList. 
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	authorsList add: 'author1'.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new authors: authorsList. 
	self assert: (materialManager search: searchSpecsWithResult) size == 1.
	authorsList add: 'author2'.
	self assert: (materialManager search: searchSpecsWithResult) size == 1.
	authorsList add: 'an author3'.
	self assert: (materialManager search: searchSpecsWithResult) size == 2.
	! !

!MaterialManagerTest methodsFor: 'searching' stamp: 'Su 5/12/2013 18:42'!
testSearchByCreationDate
	| searchSpecsNoResult searchSpecsWithResult |
	nonEmptyMaterialList := Data materialList copy.
	Data materialList: nonEmptyMaterialList.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new creationDateStart: (TimeStamp now plusSeconds: 4); creationDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new creationDateStart: (TimeStamp now minusSeconds: 14); creationDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsWithResult) size == 2.! !

!MaterialManagerTest methodsFor: 'searching' stamp: 'Su 5/12/2013 22:46'!
testSearchByDescription
	| searchSpecsNoResult searchSpecsWithResult |
	Data materialList: nonEmptyMaterialList.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new description:  'wrong description'.
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new description: 'description'.
	self assert: (materialManager search: searchSpecsWithResult) size == 1.! !

!MaterialManagerTest methodsFor: 'searching' stamp: 'Su 5/12/2013 22:01'!
testSearchByLastUploadDate
	| searchSpecsNoResult searchSpecsWithResult |
	nonEmptyMaterialList := Data materialList copy.
	Data materialList: nonEmptyMaterialList.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new lastUploadDateStart: (TimeStamp now plusSeconds: 4); lastUploadDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new lastUploadDateStart: (TimeStamp now minusSeconds: 14); lastUploadDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsWithResult) size == 2.! !

!MaterialManagerTest methodsFor: 'searching' stamp: 'Su 5/12/2013 22:56'!
testSearchByLicence
	| searchSpecsNoResult searchSpecsWithResult |
	nonEmptyMaterialList add: (DidacticMaterial new licence: 'none').
	Data materialList: nonEmptyMaterialList.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new licence:  'wrong licence'.
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new licence: 'none'.
	self assert: (materialManager search: searchSpecsWithResult) size == 1.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new licence: 'GPLv3'.
	self assert: (materialManager search: searchSpecsWithResult) size == 2.
	
	! !

!MaterialManagerTest methodsFor: 'searching' stamp: 'Su 5/12/2013 22:08'!
testSearchByOwner
	| searchSpecsNoResult searchSpecsWithResult |
	Data materialList: nonEmptyMaterialList.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new owner:  'wrong_owner@email.com'.
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new owner: 'user@email.com'.
	self assert: (materialManager search: searchSpecsWithResult) size == 1.! !

!MaterialManagerTest methodsFor: 'searching' stamp: 'Su 5/12/2013 23:45'!
testSearchByTags
	| searchSpecsNoResult searchSpecsWithResult|
	Data materialList: nonEmptyMaterialList.
	tags := SortedCollection new.
	authorsList add: 'wrong tag'.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new tags: tags. 
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	tags := OrderedCollection new. 
	tags add: 'OOP'.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new tags: tags. 
	self assert: (materialManager search: searchSpecsWithResult) size == 1.
	authorsList add: 'Smalltalk'.
      searchSpecsWithResult := DidacticMaterialSearchSpecs new tags: tags.
	self assert: (materialManager search: searchSpecsWithResult) size == 1.
	tags add: 'DNA'.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new tags: tags.
	self assert: (materialManager search: searchSpecsWithResult) size == 2.
	! !

!MaterialManagerTest methodsFor: 'searching' stamp: 'jsa 5/11/2013 19:34'!
testSearchByTitle
	| searchSpecsNoResult searchSpecsWithResult |
	Data materialList: nonEmptyMaterialList.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new title: 'wrong title'.
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new title: 'title'.
	self assert: (materialManager search: searchSpecsWithResult) size == 1.! !

!MaterialManagerTest methodsFor: 'searching' stamp: 'jsa 5/11/2013 19:43'!
testSearchByTitleAndCreationDate
	| searchSpecsNoResult searchSpecsWithResult |
	Data materialList: nonEmptyMaterialList.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new title: 'title'; creationDateStart: (TimeStamp now plusSeconds: 4); creationDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new title: 'title'; creationDateStart: (TimeStamp now minusSeconds: 14); creationDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsWithResult) size == 1.! !

!MaterialManagerTest methodsFor: 'searching' stamp: 'Su 5/12/2013 18:19'!
testSearchByTitleAndLastUploadDate
	| searchSpecsNoResult searchSpecsWithResult |
	Data materialList: nonEmptyMaterialList.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new title: 'title'; lastUploadDateStart: (TimeStamp now plusSeconds: 4); lastUploadDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new title: 'title'; lastUploadDateStart: (TimeStamp now minusSeconds: 14); lastUploadDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsWithResult) size == 1.! !

!MaterialManagerTest methodsFor: 'searching' stamp: 'Su 5/13/2013 00:04'!
testSearchByType
	| searchSpecsNoResult searchSpecsWithResult |
	Data materialList: nonEmptyMaterialList.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new type: 'wrong type'.
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new type: 'slide show'.
	self assert: (materialManager search: searchSpecsWithResult) size == 1.! !

!MaterialManagerTest methodsFor: 'submitting' stamp: 'Su 5/12/2013 21:40'!
testSubmitMaterial
	Data materialList: emptyMaterialList.
	materialManager submitMaterial: submittedFile title: 'title' authors: authorsList description: 'description' type: 'slide show' licence: 'GPLv3' tags: tags.
	self assert: (materialManager materialList select: [:material | material title = 'title']) size == 1.! !

!MaterialManagerTest methodsFor: 'submitting' stamp: 'cmb 6/25/2013 21:35'!
testSubmitMaterialAutomaticFields
	| loggedUser now maxDuration|
	Data materialList: emptyMaterialList.
	loggedUser := OcUser new email: 'user@email.com'.
	Session user: loggedUser.
	maxDuration := Duration seconds: 1.
	now := TimeStamp now.
	materialManager submitMaterial: submittedFile title: 'title' authors: authorsList description: 'description' type: 'slide show' licence: 'GPLv3' tags: tags.
	self assert: (materialManager materialList select: [:material | material owner = loggedUser and: material creationDate - now <  maxDuration and: material lastUploadDate - now < maxDuration]) size == 1.
	self assert: (materialManager materialList select: [:material | material url = 'user@email.com/title']) size == 1! !

!MaterialManagerTest methodsFor: 'submitting' stamp: 'jsa 5/11/2013 18:37'!
testSubmitMaterialWithoutLogin
	Data materialList: emptyMaterialList.
	Session user: nil.
	self should: [materialManager submitMaterial: submittedFile title: 'title' authors: authorsList description: 'description' type: 'slide show' licence: 'GPLv3' tags: tags] raise: Error.
	self assert: (materialManager materialList select: [:material | material title = 'title']) size == 0.! !

TestCase subclass: #UserManagerTest
	instanceVariableNames: 'emptyUserList nonEmptyUserList userManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Tests'!

!UserManagerTest methodsFor: 'running' stamp: 'Su 5/13/2013 17:08'!
setUp
	Data blankData.
	emptyUserList := Data userList copy.
	userManager := UserManager new.
	userManager registerNewUser: 'john' password: '123admin' email: 'johnadmin@me.com'.
	nonEmptyUserList := Data userList copy.
	userManager login: 'johnadmin@me.com' password: '123admin'.
	Data admin: nil.
	! !

!UserManagerTest methodsFor: 'testing' stamp: 'Su 5/13/2013 17:33'!
testChangeEmail
	| mockUser |
	"Deveria dar erro quando email j est cadastrado"
	self should: [userManager changeEmail: Session user newEmail:  Session user email] raise: Error.
	mockUser := Session user copy.
	userManager changeEmail: Session user newEmail: 'johnadmin@newemail.com'.
	self assert: [Session user email = 'johnadmin@newemail.com'].
	self assert: [Data userList includes: Session user].
	self shouldnt: [Data userList includes: mockUser]! !

!UserManagerTest methodsFor: 'testing' stamp: 'cmb 6/25/2013 21:35'!
testChangeEmailLoggedAsAdmin
	| oldUser user |
	oldUser := Session user copy.
	user := Session user.
	userManager login: 'admin' password: 'admin'.
	"Deveria dar erro quando email j est cadastrado"
	self should: [userManager changeEmail: user newEmail:  user email] raise: Error.
	userManager changeEmail: user newEmail: 'johnadmin@newemail.com'.
	self assert: [Session user email = 'admin'].
	self assert: [Data userList includes: (OcUser new email: 'johnadmin@newemail.com')].
	self shouldnt: [Data userList includes: oldUser].
! !

!UserManagerTest methodsFor: 'testing' stamp: 'Su 5/13/2013 17:46'!
testChangeEmailWithoutLogin
	| oldUser |
	oldUser := Session user.
	Session user: nil.
	self should: [userManager changeEmail:  oldUser newEmail: 'blabla'] raise: Error
! !

!UserManagerTest methodsFor: 'testing' stamp: 'cmb 6/25/2013 21:35'!
testChangeEmailWithoutPermission
	| oldUser |
	oldUser := Session user.
	Session user: (OcUser new email: 'another_user@email.com').
	self should: [userManager changeEmail:  oldUser newEmail: 'blabla'] raise: Error
! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 5/13/2013 17:40'!
testChangeName
	| newName |
	newName := 'new_name'.
	userManager changeName: Session user newName: newName.
	self assert: [Session user name = newName].
	self assert: [Data userList includes: Session user]! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 5/13/2013 19:17'!
testChangeNameLoggedAsAdmin
	| user newName |
	user := Session user copy.
	userManager login: 'admin' password: 'admin'.
	newName := 'new_name'.
	userManager changeName: user newName: newName.
	self assert: [Session user email = 'admin'].
	self assert: [Data userList includes: user].
	self assert: [(Data userList select: [ :anUser | anUser = user and: anUser name = newName]) size = 1].! !

!UserManagerTest methodsFor: 'testing' stamp: 'cmb 6/25/2013 21:35'!
testChangeNameWithoutPermission
	| oldUser |
	oldUser := Session user.
	Session user: (OcUser new email: 'another_user@email.com').
	self should: [userManager changeName: oldUser newName: 'blabla'] raise: Error! !

!UserManagerTest methodsFor: 'testing' stamp: 'Su 5/13/2013 17:21'!
testChangePassword
	| newPassword |
	newPassword := 'new_password'.
	userManager changePassword: Session user newPassword: newPassword.
	self assert: [Session user password = newPassword].
	self assert: [Data userList includes: Session user]
! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 5/13/2013 19:17'!
testChangePasswordLoggedAsAdmin
	| newPassword oldUser|
	newPassword := 'new_password'.
	oldUser := Session user.
      userManager login: 'admin' password:'admin'.
	userManager changePassword: oldUser newPassword: newPassword.
	self assert: [Session user email = 'admin'].
	self assert: [oldUser password = newPassword].
	self assert: [Data userList includes: oldUser]
! !

!UserManagerTest methodsFor: 'testing' stamp: 'Su 5/13/2013 17:56'!
testChangePasswordWithoutLogin
	| oldUser |
	oldUser := Session user.
	Session user: nil.
	self should: [userManager changePassword:  oldUser newPassword: 'new_password'] raise: Error.
	self assert: Session user isNil
! !

!UserManagerTest methodsFor: 'testing' stamp: 'cmb 6/25/2013 21:35'!
testChangePasswordWithoutPermission
	| oldUser |
	oldUser := Session user.
	Session user: (OcUser new email: 'another_user@email.com').
	self should: [userManager changePassword:  oldUser newPassword: 'new_password'] raise: Error.
	self assert: (Session user email = 'another_user@email.com')
! !

!UserManagerTest methodsFor: 'testing' stamp: 'cmb 6/25/2013 21:35'!
testFirstAdminLogin
	Data userList: emptyUserList.
	Data admin: nil.
	Session user: nil.
	self
		should: [userManager login: 'admin' password: 'admin'.
			Session user = Data admin and: (Data admin isNil) not 
			and: (userManager userList includes: (OcUser new email: 'admin'))].
	Session user: nil.
	self
		should: [userManager login: 'admin' password: 'admin'.
			Session user = Data admin and: (Data admin isNil) not 
			and: (userManager userList includes: (OcUser new email: 'admin'))]! !

!UserManagerTest methodsFor: 'testing' stamp: 'cmb 6/25/2013 21:35'!
testLogin
	| loggedUser |
	Data userList: nonEmptyUserList.
	self
		should: [userManager login: 'emailDoesntExist' password: '123admin']
		raise: Error.
	self
		should: [userManager login: 'johnadmin@me.com' password: 'wrongPassword']
		raise: Error.
	loggedUser := OcUser new email: 'johnadmin@me.com'.
	self
		should: [userManager login: 'johnadmin@me.com' password: '123admin'.
			Session user = loggedUser]! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 5/13/2013 19:31'!
testLogoff
	(Session user == nil)
		ifFalse: [
			userManager logoff.
			self assert: [Session user == nil]
			].! !

!UserManagerTest methodsFor: 'testing' stamp: 'cmb 6/25/2013 21:35'!
testRegisterNewUser
	| createdUser |
	createdUser := OcUser new name: 'john';
				 password: '123admin';
				 email: 'johnadmin@me.com'.
	Data userList: emptyUserList.
	self
		shouldnt: [userManager hasUser: createdUser].
	userManager
		registerNewUser: 'john'
		password: '123admin'
		email: 'johnadmin@me.com'.
	self
		assert: (userManager hasUser: createdUser)! !

!UserManagerTest methodsFor: 'testing' stamp: 'cmb 6/25/2013 21:35'!
testRemoveUser
	| listSize currentUser|
	currentUser := Session user.
	
	"try to remove an unexistent user"
	self should: [userManager removeUser: (OcUser new email: 'wrong@email.com')] raise: Error.
	
	"try to remove unlogged"
	Session user: nil.
	self should: [userManager removeUser: currentUser] raise: Error.
	
	"try to remove correct"
	Session user: currentUser.
	listSize := Data userList size.
	userManager removeUser: currentUser.
	self assert: [listSize > Data userList size].
	! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 5/13/2013 19:35'!
testRemoveUserLoggedAsAdmin
	| listSize currentUser|
	currentUser := Session user.
	userManager login: 'admin' password:'admin'.
	listSize := Data userList size.
	userManager removeUser: currentUser.
	self assert: [listSize > Data userList size].
	self assert: [Session user email = 'admin'].
	! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 5/11/2013 18:31'!
testTryToRegisterAnAlreadyRegisteredUser
	Data userList: nonEmptyUserList.
	self
		should: [userManager
				registerNewUser: 'jon'
				password: '123admin321'
				email: 'johnadmin@me.com']
		raise: Error! !
